% This program is to demonstrate the Contrast-guided interpolation algorithm.
% Wei Zhe and Kai-Kuang Ma 11/11/2011.
% EEE, NTU, Singapore.
% Hong Zheng:The code keeps 1/4 pixels of the original LR image 11/30/2014 
function y=main(low_x)
ORG=low_x;

down = 0.5;
mag  = 1; 

cut_size =  4;
cut_size = (2^(mag-1))*cut_size;
[N,M,z] = size(ORG);

if z == 1 
%grayscale image
    TL  =ORG(1:down*2:N,1:down*2:M);
    
    %Bicubic interpolation
    I_cubic = func_MyInterp2(TL,2^mag,'cubic');
%     I_cubic = round(I_cubic);
%     I_cubic = round(I_cubic);
    I_cubic(I_cubic<0)=0;
    I_cubic(I_cubic>255)=255;

    %Contrast_guided image interpolation
    I_contrast = contrast_guided(TL, mag);
%     I_contrast = round(I_contrast);
    I_contrast(I_contrast<0)=0;
    I_contrast(I_contrast>255)=255;

    % Cut the edge of image and calculate PSNR,.
%     ORG = cut_image (ORG, cut_size);
%     I_cubic = cut_image (I_cubic, cut_size); 
%     I_contrast = cut_image (I_contrast, cut_size);
%     if mag == down
%         cubic_psnr = psnr(I_cubic(:,:,1),ORG(:,:,1));
%         display('Bicubic method (dB): ' );
%         display(num2str(cubic_psnr));
%         contrast_psnr = psnr(I_contrast(:,:,1),ORG(:,:,1));
%         display('Contrast-guided method (dB): ');
%         display(num2str(contrast_psnr));
%     end
elseif z == 3
    cut = 0;
    for i = 1:3
        if ((N - 2*cut_size)*(M - 2*cut_size)* 2^mag* 2^mag)/(4*down*down) > 2800*1200
        display('(Note: The input image is too large, we need to cut down the image size)');
        % Calculates how many boundary pixels will be cut away.
        p = [4 -2*M-2*N  N*M-2800*1200/(2^mag*2^mag)];
        cut_size = max(min(ceil(roots(p))),0);
        cut = 1;
        end
        
        if cut == 1
            TL  = cut_image(ORG(1:down*2:N,1:down*2:M, i), cut_size);
        else 
            TL  = ORG(1:down*2:N,1:down*2:M,i);
        end

        %Bicubic interpolation
        I_cubic_c = func_MyInterp2(TL,2^mag,'cubic');
        I_cubic_c = round(I_cubic_c);
        I_cubic_c(I_cubic_c<0)=0;
        I_cubic_c(I_cubic_c>255)=255;
        I_cubic_cut = cut_image(I_cubic_c, cut_size); 
        I_cubic(:,:,i) = I_cubic_cut;

        %Contrast_guided image interpolation
        I_contrast_c = contrast_guided(TL, mag);
        I_contrast_c = round(I_contrast_c);
        I_contrast_c(I_contrast_c<0)=0;
        I_contrast_c(I_contrast_c>255)=255;
        I_contrast_cut = cut_image(I_contrast_c, cut_size); 
        I_contrast(:,:,i) = I_contrast_cut;           
    end
end

%%

y=I_contrast;
 


