% Matlab algorithm for Multi-Contrast MRI Super-Resolution with Similar Anatomical Structures.
% Author: Hong Zheng and Xiaobo Qu
% Homepage: http://www.quxiaobo.org
% Email: quxiaobo <|at|> xmu.edu.cn
% Affiliations:
% (a) Computational Sensing Group, Xiamen University, Xiamen 361005, China
% (b) Departments of Electronic Science, Xiamen University, Xiamen 361005, China
% (c) Fujian Key Laboratory of Plasma and Magnetic Resonance, Xiamen University, Xiamen 361005, China
%%
clc;clear;close all;
%%
Path_MultiContrastMRI_SR
%%    input test image name
prefixed_name='Pen2';
T1=strcat(prefixed_name,'_t1');
T2=strcat(prefixed_name,'_t2');
%%   the ground-truth image
load (T2);
x=abs(eval(T2));
x=x/max(x(:));
xmax=max(max(x));xmin=min(min(x));
figure(1);imshow(x,[0,1]); 
title('original image');
%%   
[M,N]=size(x);
psf=fspecial('gaussian',3,0.5);
low_x=imfilter(x,psf,'conv','symmetric');
low_x=low_x(1:2:M,1:2:N);
%%   the reference image 
load (T1);  
im=abs(eval(T1));
im=im/max(im(:));
figure(2);imshow(im,[0,1]);  
title('reference image');
%%
im=imfilter(im,psf,'conv','symmetric');
%%
Bi=imresize(low_x,2,'bicubic');
Evalu_Bi=Evaluation_CS_MRI(x,Bi);
figure(3);imshow(Bi,[0,1]); 
title('Bicubic');
PSNR_Bicubic=Evalu_Bi(1);SSIM_Bicubic=Evalu_Bi(4);RLNE_Bicubic=Evalu_Bi(5);
%%
NEDI=sri(low_x,1,xmax,xmin);
Evalu_NEDI=Evaluation_CS_MRI(x,NEDI);
figure(4);imshow(NEDI,[0,1]);      
title('NEDI');
PSNR_NEDI=Evalu_NEDI(1);SSIM_NEDI=Evalu_NEDI(4);RLNE_NEDI=Evalu_NEDI(5);
%%
CGI=main(low_x);
Evalu_CGI=Evaluation_CS_MRI(x,CGI);
figure(5);imshow(CGI,[0,1]);             
title('CGI');
PSNR_CGI=Evalu_CGI(1);SSIM_CGI=Evalu_CGI(4);RLNE_CGI=Evalu_CGI(5);
%%
y=sri_contr(low_x,1,xmax,xmin,im); 
Evalu_proposed=Evaluation_CS_MRI(x,y);
figure(6);imshow(y,[0,1]);     
title('the proposed');
PSNR_proposed=Evalu_proposed(1);SSIM_proposed=Evalu_proposed(4);RLNE_proposed=Evalu_proposed(5);