% Matlab algorithm for Multi-Contrast MRI Super-Resolution with Similar Anatomical Structures.
% Author: Hong Zheng and Xiaobo Qu
% Homepage: http://www.quxiaobo.org
% Email: quxiaobo <|at|> xmu.edu.cn
% Affiliations:
% (a) Computational Sensing Group, Xiamen University, Xiamen 361005, China
% (b) Departments of Electronic Science, Xiamen University, Xiamen 361005, China
% (c) Fujian Key Laboratory of Plasma and Magnetic Resonance, Xiamen University, Xiamen 361005, China
%%
clc;clear;close all;
%%  input parameters: p, q
p=0;    q=0.78;
% p=0.39;    q=0.78;
% p=0.76;    q=0.78;
%%
win=zeros(9)+p;
t=5;
for i=5:-1:1
    if mod(i,2)==0
        t=t-1;
    end
    win(i,1:t)=q;
    win(10-i,1:10-t)=q;    
end
w_5=win;
figure(1);imshow(w_5,[0,1]);
%%
win=zeros(9)+q;
t=5;
for i=5:-1:1
    if mod(i,2)==0
        t=t-1;
    end
    win(i,1:t)=p;
    win(10-i,1:10-t)=p;    
end
w_6=win;
figure(2);imshow(w_6,[0,1]);
%%
ix=[-1 -1 1 1];
iy=[-1 1 -1 1];
cnt=1;
for i=-3:3
   for j=-3:3
      nx(cnt)=i;ny(cnt)=j;cnt=cnt+1;
  end
end
for k=1:4
       X_5(:,k)=diag(w_5(5+ix(k)+nx,5+iy(k)+ny));
       X_6(:,k)=diag(w_6(5+ix(k)+nx,5+iy(k)+ny));
end
y_5=diag(w_5(5+nx,5+ny));
y_6=diag(w_6(5+nx,5+ny));
%%  
b_5=inv(X_5'*X_5)*X_5'*y_5;
s_5=sum(b_5);
b_6=inv(X_6'*X_6)*X_6'*y_6;
s_6=sum(b_6);




