% Matlab algorithm for Multi-Contrast MRI Super-Resolution with Similar Anatomical Structures.
% Author: Hong Zheng and Xiaobo Qu
% Homepage: http://www.quxiaobo.org
% Email: quxiaobo <|at|> xmu.edu.cn
% Affiliations:
% (a) Computational Sensing Group, Xiamen University, Xiamen 361005, China
% (b) Departments of Electronic Science, Xiamen University, Xiamen 361005, China
% (c) Fujian Key Laboratory of Plasma and Magnetic Resonance, Xiamen University, Xiamen 361005, China
%%
clc;clear;close all;
%%
Path_MultiContrastMRI_SR
%% Load test images (brainweb_data_1,brainweb_data_2,brainweb_data_3 or brainweb_data_4) to compute weights
image_name='brainweb_data_1';
%%
load (image_name);
im1=abs(eval(image_name));
im1=im1/max(max(im1));
figure(1);imshow(im1,[0,1]);
%%    input block location 
cut_map=[121 128 8 8];      % Fig.3(a)-(d)
% cut_map=[101 115 8 8];    % Fig.3(e)
% cut_map=[57 159 8 8];     % Fig.3(f)
% cut_map=[145 125 8 8];    % Fig.3(g)
%%
rectangle('Position',cut_map,'Curvature',[0,0],'LineWidth',1,'LineStyle','-','EdgeColor','r');
im1=imcrop(im1,cut_map);
amplify_im1=imresize(im1,8,'nearest');
figure(2);imshow(amplify_im1,[0,1]);
rectangle('Position',[1,1,71,71],'Curvature',[0,0],'LineWidth',1,'LineStyle','-','EdgeColor','r');
%%
ix=[-1 -1 1 1];
iy=[-1 1 -1 1];
cnt=1;
for i=-3:3
   for j=-3:3
      nx(cnt)=i;ny(cnt)=j;cnt=cnt+1;
  end
end

for i=5
    for j=5       
        for k=1:4
        C1(:,k)=diag(im1(i+ix(k)+nx,j+iy(k)+ny));
        end
        r1=diag(im1(i+nx,j+ny));  
    end
end
%%  
a1=inv(C1'*C1)*C1'*r1;
s1=sum(a1);