% Matlab algorithm for Multi-Contrast MRI Super-Resolution with Similar Anatomical Structures.
% Author: Hong Zheng and Xiaobo Qu
% Homepage: http://www.quxiaobo.org
% Email: quxiaobo <|at|> xmu.edu.cn
% Affiliations:
% (a) Computational Sensing Group, Xiamen University, Xiamen 361005, China
% (b) Departments of Electronic Science, Xiamen University, Xiamen 361005, China
% (c) Fujian Key Laboratory of Plasma and Magnetic Resonance, Xiamen University, Xiamen 361005, China
%%
clc;clear;close all;
%%
Path_MultiContrastMRI_SR
%%   input block location
cut_map=[188 130 8 8]; 
% cut_map=[168 219 8 8]; 
%%
load Pen2_t1;
im1=abs(Pen2_t1);
im1=im1/max(max(im1));
figure(1);imshow(im1,[0,1]);
rectangle('Position',cut_map,'Curvature',[0,0],'LineWidth',1,'LineStyle','-','EdgeColor','g');
im1=imcrop(im1,cut_map);
figure(2);imshow(im1,[0,1]);
amplify_im1=imresize(im1,8,'nearest');
figure(3);imshow(amplify_im1,[0,1]);
rectangle('Position',[1,1,71,71],'Curvature',[0,0],'LineWidth',3,'LineStyle','-','EdgeColor','g');
%%
load Pen2_t2;
im2=abs(Pen2_t2);
im2=im2/max(max(im2));
figure(4);imshow(im2,[0,1]);
rectangle('Position',cut_map,'Curvature',[0,0],'LineWidth',1,'LineStyle','-','EdgeColor','g');
im2=imcrop(im2,cut_map);
figure(5);imshow(im2,[0,1]);
amplify_im2=imresize(im2,8,'nearest');
figure(6);imshow(amplify_im2,[0,1]);
rectangle('Position',[1,1,71,71],'Curvature',[0,0],'LineWidth',3,'LineStyle','-','EdgeColor','g');
%%
ix=[-1 -1 1 1];
iy=[-1 1 -1 1];
cnt=1;
for i=-3:3
   for j=-3:3
      nx(cnt)=i;ny(cnt)=j;cnt=cnt+1;
   end
end

i=5;j=5;
            for k=1:4
                C1(:,k)=diag(im1(i+ix(k)+nx,j+iy(k)+ny));
            end
            r1=diag(im1(i+nx,j+ny));         
            if det(C1'*C1)==0  
                a1=ones(4,1)/4;
            else
                a1=inv(C1'*C1)*C1'*r1;
            end            
            
                      
            for k=1:4
                C2(:,k)=diag(im2(i+ix(k)+nx,j+iy(k)+ny));
            end
            r2=diag(im2(i+nx,j+ny));
            if det(C2'*C2)==0
                a2=ones(4,1)/4;
            else
                a2=inv(C2'*C2)*C2'*r2;      
            end

  
       

       
       