function y=sri1_contr(x,xmax,xmin,im)
%%
% Matlab algorithm for Multi-Contrast MRI Super-Resolution with Similar Anatomical Structures.
% Author: Hong Zheng and Xiaobo Qu
% Homepage: http://www.quxiaobo.org
% Email: quxiaobo <|at|> xmu.edu.cn
% Affiliations:
% (a) Computational Sensing Group, Xiamen University, Xiamen 361005, China
% (b) Departments of Electronic Science, Xiamen University, Xiamen 361005, China
% (c) Fujian Key Laboratory of Plasma and Magnetic Resonance, Xiamen University, Xiamen 361005, China
%%
% Updating the pixel value in the position of (2*i,2*j)
%%
[M,N]=size(x);
for i=1:2
   for j=1:2
      y(i:2:2*M,j:2:2*N)=x;
   end
end
ix=[-1 -1 1 1];
iy=[-1 1 -1 1];
mx=[0 0 1 -1];
my=[-1 1 0 0];
cnt=1;

for i=-3:3
   for j=-3:3
      nx(cnt)=i;ny(cnt)=j;cnt=cnt+1;
  end
end

[M,N]=size(im);
th=0.0001;
T=5;
for i=2*T:2:M-2*T
   for j=2*T:2:N-2*T 
                
       for k=1:4
          C(:,k)=diag(im(i+ix(k)+nx,j+iy(k)+ny));
       end
       r=diag(im(i+nx,j+ny));      
       s=diag(y(i+ix,j+iy));       
       
       if det(C'*C)==0||var(s)<th
           a=ones(4,1)/4;             
       else
           a=inv(C'*C)*C'*r;         
       end        
         
       if abs(sum(a))>2
           a=ones(4,1)/4;
       end
       
%        if mean(s)>0.7 & var(s)<0.05
%            a=ones(4,1)/4;
%        end
  
       y(i,j)=sum(a.*s); 
       if y(i,j)<xmin||y(i,j)>xmax 
           a=ones(4,1)/4;y(i,j)=sum(a.*s);              
       end        
     
   end
end





